//"intedkfk.sci","Integracja DK do FK - include","\Integracja z FK a\",0,1.0.0,SYSTEM
////////////////////
// intedkfk.sci
// Integracja DK do FK - include
#define APOSTROF				"\t"

#define ROWNOLEGLE_KSIEG_MAG	0x1
#define NIE_EKSP_OZNAK			0x2

#define BFLAGdpDOKOMPL			0x4000		// pozycja z kompletu
#define lOPIS	200

int Sub IntegrDK(long idDK, int iOpcje)
	Dispatch xRozrachunek
	Dispatch xKZ

	IntegrDK = 0

	string sTyp
	int err
	int bKorekta = 0, bRozliczony
	int nCount = 1
	int nPozycja = 0
	dispatch dpStVat
	int iRejVat, iPom, iPomStVat, iPos
	int index = 1
	int IDFK_K
	String strOkres
	float dKwota, dKurs
	string sRej,sParam
	long lSuper
	String strTmp
	int iSubtyp, nWalutowy
	int iRok, iRok2
	long ii
	Dispatch xKontrahent
	Dispatch xDokSp
	Dispatch xTypDokumentuSp
	Dispatch xKsSchematSp
	Dispatch xTowar
	Dispatch xParams
	Dispatch xDefDok
	int czyRelatedDokument = 0
	string xmlDoc, s1,s2
	int iOkresSter, k
	int czyPozycjaVAT = 0, czyDEX = 0

	Dispatch xIntegracja = xFactory.GetObject("BIntegracjaFK")

	nRes=!(xDokumentSp=GetObjById("BDokumentSp",idDK))
	if nRes then  Error "Brak takiego rekordu w bazie DK"

	iSubtyp = xDokumentSp.charakter

	if iSubtyp == SKO || iSubtyp == SKK then
		buf = xDokumentSp.dataRealizacji
		iRok = dbd.firmainfo.GetRokByDate(xDokumentSp.dataRealizacji)
	else
		//  na podstawie definicji typu dokumentu w FK okreslamy rok dla wszystkich pozostaych dokumentow
		buf = xDokumentSp.dataWystawienia
		iRok2 = dbd.firmainfo.GetRokByDate(xDokumentSp.dataWystawienia)
		if iRok2 == -3 then  //rok zamkniety
			IntegrDK = ZamknietyRok(1, xDokumentSp.numer, buf, idDK)
			if IntegrDK then exit
		endif
		xTypDokumentuSp = GetObjByKod("BTypDokumentuSp", xDokumentSp.typDK)
		if !xTypDokumentuSp then  error "Brak takiego rekordu"
		sParam = using "%d", iRok2
		xDefDok.Create(ObjectFK(".DefDokum"))
		xDefDok.Open(sParam, dbd)
		xDefDok.MoveTo(xTypDokumentuSp.typFK)
		iOkresSter = xDefDok.Value("konfOkres")
		if iOkresSter == 1 then//data operacji gospodarczej
			iRok = dbd.firmainfo.GetRokByDate(xDokumentSp.dataSprzedazy)
			if iRok == -3 then //warning
				IntegrDK = ZamknietyRok2(1, xDokumentSp.numer, xDokumentSp.dataSprzedazy, idDK, 1)
				if IntegrDK then exit
				iRok = dbd.firmainfo.GetRokByDate(xDokumentSp.dataWystawienia) //data dokumentu
			endif
		else
			iRok = dbd.firmainfo.GetRokByDate(xDokumentSp.dataWystawienia) //data dokumentu
		endif
	endif

	if iRok < 0 then
		IntegrDK = ZamknietyRok(1, xDokumentSp.numer, buf, idDK)
		if IntegrDK then exit
	endif

	if RokFK(1).Zap == 1 then

		if RokFK(1).IdRok != iRok then
			UstawRok(iRok)
		endif

	else
		UstawRok(iRok)
	endif

	dst=RokFK(1).Rok
	plkn=RokFK(1).PlanKont
	defdok=RokFK(1).DefDokument
	rozrDokument=RokFK(1).RokDokumentRoz

	Select Case xDokumentSp.charakter
	Case DXK, DEX, WDT, WDK, REX, RXK, FVS, FKS ,FVW, FKW
		if ItgInfo.Info("PozycjaVAT") then czyPozycjaVAT = 1
		if xDokumentSp.charakter == DEX || xDokumentSp.charakter == DXK then	czyDEX = 1
	Case Else
			czyPozycjaVAT = 0
	EndSelect

	// sprawdzamy typ dokumentu
	Select Case xDokumentSp.charakter
		Case FVS, FKS, RUS, RKS, DXK, DEX, FAS, FAK, PAR, PRK, FVW, FKW, FZS, ZKS, WDT, FWS, WKS, WDK, FVT, FTK, REX, RXK, SZA, SZK, SKO, SKK
		Case Else
			IntegrDK = 1 // pomijamy
			AddError("Nie mona wysa dokumentu " + xDokumentSp.numer+".",idDK)
	EndSelect
	
	if ( IntegrDK == 1 ) then Exit

	//dla wspolnej bazy - sprawdzamy czy dokument, zostal zapisany w RDF
	if (xIntegracja.CzyItgXML == 1 && !xDokumentSp.statusRDF) then
		if CzyIntegrSentToFK(xDokumentSp.numer, idDK) then Exit // pomijamy
	endif
		
	if CzyIntegrBrakSchematu(xDokumentSp.schematKsiegowania, xDokumentSp.numer, idDK) then
		IntegrDK = 1 // pomijamy
		Exit
	endif

	xKsSchematSp = GetObjByKod("BKsSchematSp", xDokumentSp.schematKsiegowania)
	if xKsSchematSp then
		nRes = 0
	else
		nRes = 1
	endif

	if CzyIntegrBlednySchemat(nRes, xDokumentSp.numer, idDK) then
		IntegrDK = 1 // pomijamy
		Exit
	endif

	if 0 != xDokumentSp.danekh.KhId then

		xKontrahent = GetObjById("BKontrahent", xDokumentSp.danekh.KhId)
		if !xKontrahent then  error "Brak takiego rekordu w bazie KH"

		if ( 1 != xIntegracja.trybWspolpracy && 4 != xIntegracja.trybWspolpracy) then
			IntegrDK = CzyIntegrBrakIDFK(val(xKontrahent.identyfikatorFK), xDokumentSp.numer, idDK)
			if IntegrDK then exit
		endif
	endif

	sTyp = xDokumentSp.typDk


	nRes = !(xDokSp=GetObjById("BDokSp",idDK))
	if nRes then  error "Dokument nie zaadowany"
	if xDokSp.czyZaimport then
		//dokument moze miec typ dokumentu wprowadzony tylko w centrali
		// sprawdzamy czy ma taki typ

		xTypDokumentuSp = GetObjByKod("BTypDokumentuSp", xDokumentSp.typDk)

		sTyp = ""
		if xTypDokumentuSp && (xDokumentSp.charakter == xTypDokumentuSp.charakter) then
			// typ dokumentu pasuje z odzdialu z centrala
			sTyp = xDokumentSp.typDk
		else
			// nie znaleizono typu o takim kodzie wiec
			// szukamy dla podstawowego typu dla charakteru dokumentu
			xTypDokumentuSp = GetObjByKod("BTypDokumentuSp", TypDOK(xDokumentSp.charakter))
			if xTypDokumentuSp && (xDokumentSp.charakter == xTypDokumentuSp.charakter) then
				sTyp = xDokumentSp.typDk
			else
				IntegrDK = CzyIntegrBrakTypDK("", xDokumentSp.numer, idDK, TypDOK(xDokumentSp.charakter))
			endif
		endif
	endif


	if !(xDokSp.czyZaimport) || ((xDokSp.czyZaimport) && sTyp != "") then

		xTypDokumentuSp = GetObjByKod("BTypDokumentuSp", sTyp)
		if !xTypDokumentuSp then  error "Brak takiego rekordu"

		IntegrDK = CzyIntegrBrakTypDK(xTypDokumentuSp.symbolFK, xDokumentSp.numer, idDK, sTyp)
	endif
	if IntegrDK then exit

	iSubtyp = xDokumentSp.charakter
	//sprawdzamy czy faktury walutowe nie sa eksportowane jako stare( nie walutowe) do FK
	if(iSubtyp == FVW || iSubtyp == FKW)  && (xTypDokumentuSp.typFK != "FWS" && xTypDokumentuSp.typFK != "FWSK") then
 		if(xDokumentSp.kurs != xDokumentSp.kursDoch) then
			nRes = 1
		else
			nRes = 0
		endif
	endif
	IntegrDK = CzyIntegrBlednyTypFK(nRes, xTypDokumentuSp.symbolFK, xDokumentSp.numer, idDK, sTyp)
	if IntegrDK then exit
/*
	//sprawdzamy, czy dokumenty zlotowkowe nie sa wysylane jako faktura walutowa
	if (xTypDokumentuSp.typFK == "FWS" || xTypDokumentuSp.typFK == "FWSK") && (xDokumentSp.waluta == "") then
		IntegrDK = CzyIntegrBlednyTypFK2(xTypDokumentuSp.symbolFK, xDokumentSp.numer, idDK, sTyp)
	endif
	
	if IntegrDK then exit
*/		
	if(xTypDokumentuSp) then
		if(xTypDokumentuSp.typFK == "FVS" || xTypDokumentuSp.typFK == "RUS" || xTypDokumentuSp.typFK == "FVZ" ||xTypDokumentuSp.typFK == "RUZ") then
		 	czyRelatedDokument = 1
		else
			czyRelatedDokument = 0
		endif
		xDokumentSp.SprawdzUzgodnienieFK()
	endif

	Select Case iSubtyp
		Case FVS, FKS, RUS, RKS, DEX, DXK, PAR, PRK, FAS, FAK, FVW, FKW, FZS, ZKS, WDT, FWS, WKS, WDK, FVT, FTK, REX, RXK, SZA, SZK //, SKO, SKK
			for ii=1 to ii>xDokumentSp.Pozycje.Count()
				if (!xDokumentSp.Pozycje.item(ii).dokompletu && ((!xDokumentSp.CzyKorekta) || (xDokumentSp.CzyKorekta && xDokumentSp.Pozycje.item(ii).wlasna))) then
					if (xDokumentSp.CzyKorekta) then
						if (xDokumentSp.Pozycje.item(ii).idpozkoryg) then
							xRejSp = xDokumentSp.Pozycje.item(ii).przedKorekta.rejestrVAT
							if xRejSp.id then
								if xRejSp.rejestrFKid then
									IntegrDK = CzyintegrBlednyRej(xRejSp.rejestrFKid, xDokumentSp.numer, idDK)
								else
									// nie ma uzgdonionego rejestru
									IntegrDK = CzyintegrBlednyRej(0, xDokumentSp.numer, idDK)
								endif
								if IntegrDK then exit
							else
								// nieokrelony rejestr
								IntegrDK = CzyintegrBrakRej(1, xDokumentSp.numer, idDK)
								if IntegrDK then exit
							endif
						endif

						xRejSp = xDokumentSp.Pozycje.item(ii).poKorekcie.rejestrVAT
						if xRejSp.id then
							if xRejSp.rejestrFKid then
								IntegrDK = CzyintegrBlednyRej(xRejSp.rejestrFKid, xDokumentSp.numer, idDK)
							else
								// nie ma uzgdonionego rejestru
								IntegrDK = CzyintegrBlednyRej(0, xDokumentSp.numer, idDK)
							endif
							if IntegrDK then exit
						else
							// nieokrelony rejestr
							IntegrDK = CzyintegrBrakRej(1, xDokumentSp.numer, idDK)
							if IntegrDK then exit
						endif
					else
						xRejSp = xDokumentSp.Pozycje.item(ii).rejestrVAT
						if xRejSp.id then
							if xRejSp.rejestrFKid then
								IntegrDK = CzyintegrBlednyRej(xRejSp.rejestrFKid, xDokumentSp.numer, idDK)
							else
								// nie ma uzgdonionego rejestru
								IntegrDK = CzyintegrBlednyRej(0, xDokumentSp.numer, idDK)
							endif
							if IntegrDK then exit
						else
							// nieokrelony rejestr
							IntegrDK = CzyintegrBrakRej(1, xDokumentSp.numer, idDK)
							if IntegrDK then exit
						endif
					endif
				endif
			next ii
	endselect

	if IntegrDK then exit

	if ( xDokumentSp.czyKorekta ) then bKorekta = 1
		bRozliczony = xDokumentSp.czyRozliczony

		dst.Clear()
		sOpisy=0
		dbd.CurrentDate = sDataWpr
		//sposb wsppracy z FK
		if(xIntegracja.currentLoadNewVersion)then//obiekt integracji obsuguje guidy dokumentw
			dst.Value("UId") = xDokumentSp.guid
		endif

		if iSubtyp == SKO || iSubtyp == SKK then
			dst.Value("DataDok") = xDokumentSp.dataRealizacji
			dst.Value("DataOper") = xDokumentSp.dataRealizacji
		else
			dst.Value("DataDok") = xDokumentSp.dataWystawienia
			//if(xDokumentSp.CzyKorekta) then
			//	dst.Value("DataOper") = xDokumentSp.dataWystawienia
			//else
				dst.Value("DataOper") = xDokumentSp.dataSprzedazy
			//endif
		endif

		dst.Value("Datawpl") = Data()
		dst.Value("Datawpr") = sDataWpr

		if xDokumentSp.danekh.KhId != 0 then
			xKontrahent = GetObjById("BKontrahent", xDokumentSp.danekh.KhId)
			if !xKontrahent then  error "Brak takiego rekordu w bazie KH"

			if ( 1 == xIntegracja.trybWspolpracy || 4 == xIntegracja.trybWspolpracy) then
				dst.Value("kontrahent") = xKontrahent.guid
			else
				dst.Value("kontrahent") = val(xKontrahent.identyfikatorFK)
			endif
		endif
		if xDokumentSp.danekh.KhKod == "" && xDokumentSp.danekh.KhNazwa != "" then
			kontrah.ClearRecord()
			kontrah.Value("nazwa") = xDokumentSp.danekh.KhNazwa
			kontrah.Value("nip") = xDokumentSp.danekh.KhNIP
			kontrah.Value("ulica") = IIF(Len(xDokumentSp.danekh.KhUlica) > lenULICA, Mid(xDokumentSp.danekh.KhUlica,0,lenULICA), xDokumentSp.danekh.KhUlica)
			kontrah.Value("nrDomu") = xDokumentSp.danekh.KhDomu
			kontrah.Value("nrMieszkania") = xDokumentSp.danekh.KhLokal
			kontrah.Value("miejscowosc") = IIF(Len(xDokumentSp.danekh.KhMiasto) > lenMIASTO, Mid(xDokumentSp.danekh.KhMiasto,0,lenMIASTO), xDokumentSp.danekh.KhMiasto)
			kontrah.Value("kodPocztowy") = xDokumentSp.danekh.KhPoczta
			IDFK_K = kontrah.CheckIfExists()
			if !IDFK_K then
				if kontrah.Validate() && (IntegrDK == 0) then
					if !kontrah.Insert() && kontrah.CheckIfExists() then
						if ItgInfo.Info("PlanKontSubjectType") then
							dst.Value("kontrahent") = kontrah.GetExistingPoz(0)
						else
							dst.Value("kontrahent") = kontrah.GetExistingId(0)
						endif
					endif
				endif
			else
				if ItgInfo.Info("PlanKontSubjectType") then
					dst.Value("kontrahent") = kontrah.GetExistingPoz(0)
				else
					dst.Value("kontrahent") = kontrah.GetExistingId(0)
				endif
			endif
		endif

		nWalutowy = 0
		if (iSubtyp != FWS && iSubtyp != WKS && iSubtyp != SKO && iSubtyp != SKK && CzyWalutowy(xDokumentSp.GetRozrachunek().id)) then
			nWalutowy = 1
		endif

		if nWalutowy then
			dKurs = xDokumentSp.kurs
			dst.Value("kurs") = dKurs
			dst.Value("waluta") = xDokumentSp.waluta

			dKwota = xDokumentSp.wysokoscNaleznosci
			dst.Value("wkwota") = dKwota
			dst.Value("kwota") = Round(dKwota * dKurs, 2)
		else
			dKwota = Round( (xDokumentSp.netto + xDokumentSp.niePodlega + xDokumentSp.vat),2 )
			dst.Value("Kwota") = dKwota
		endif

		sTyp = xDokumentSp.typDk
		if xDokSp.czyZaimport then
			//dokument moze miec typ dokumentu wprowadzony tylko w centrali
			// sprawdzamy czy ma taki typ

			xTypDokumentuSp = GetObjByKod("BTypDokumentuSp", xDokumentSp.typDk)

			sTyp = ""
			if xTypDokumentuSp && (xDokumentSp.charakter == xTypDokumentuSp.charakter) then
				// typ dokumentu pasuje z odzdialu z centrala
				sTyp = xDokumentSp.typDk
			else
				// nie znaleizono typu o takim kodzie wiec
				// szukamy dla podstawowego typu dla charakteru dokumentu
				xTypDokumentuSp = GetObjByKod("BTypDokumentuSp", TypDOK(xDokumentSp.charakter))
				if xTypDokumentuSp && (xDokumentSp.charakter == xTypDokumentuSp.charakter) then
					sTyp = xDokumentSp.typDk
				else
					error "Brak takiego rekordu w bazie DK"
				endif
			endif
		endif
		// w sumie mogloby nie byc tego wraunku bo styp musi byc
//		if !(xDokSp.item(1).czyZaimport) || ((xDokSp.item(1).czyZaimport) && sTyp != "") then
			xTypDokumentuSp = GetObjByKod("BTypDokumentuSp", sTyp)
			if !xTypDokumentuSp then  error "Brak takiego rekordu"
//		endif
		dst.Value("skrot") = xTypDokumentuSp.symbolFK

		if bKorekta then
			if xDokumentSp.czyKZ then	//korekta zbiorcza
				xKZ = xDokumentSp.dokumentyKorygowaneKZ
				k = 1
				for k to k > xKZ.Count
					dst.Powiazanie.Insert()
					dst.Powiazanie.Value("guid") = xKZ.item(k).guid
					dst.Powiazanie.Value("numerDok") = xKZ.item(k).kod
					dst.Powiazanie.Value("dataDok")  = xKZ.item(k).data
					dst.Powiazanie.Value("korekta")  = 0
				next k
			else
				// musimy siegnac do dokumentu korygowanego pierwotnego
				// przyjete ze jest to pierwszy w kolekcji
				if xDokumentSp.DokumentZKorektami.Count() && xDokumentSp.DokumentZKorektami.item(1).Numer!= xDokumentSp.Numer then
					dst.Value("NazwaKor") = xDokumentSp.DokumentZKorektami.item(1).Numer
					dst.Value("DataKor") = xDokumentSp.DokumentZKorektami.item(1).Data
					dst.Powiazanie.Insert()
					dst.Powiazanie.Value("guid") = xDokumentSp.DokumentZKorektami.item(1).guid
					dst.Powiazanie.Value("numerDok") = xDokumentSp.DokumentZKorektami.item(1).Numer
					dst.Powiazanie.Value("dataDok")  = xDokumentSp.DokumentZKorektami.item(1).Data
					dst.Powiazanie.Value("korekta")  = 0
				endif
			endif
		else
			if xDokumentSp.DokumentZKorektami.Count() && xDokumentSp.DokumentZKorektami.item(1).Numer== xDokumentSp.Numer then
				k = 2
				for k to k > xDokumentSp.DokumentZKorektami.Count()		
					dst.Powiazanie.Insert()
					dst.Powiazanie.Value("numerDok") = xDokumentSp.DokumentZKorektami.item(k).Numer
					dst.Powiazanie.Value("dataDok")  = xDokumentSp.DokumentZKorektami.item(k).Data
					dst.Powiazanie.Value("korekta")  = 1
				next k
			endif
		endif
		
		// pozycje dokumentu
		////////////////////////[Pozycja VAT]//////////////////////////

		if nWalutowy && (xTypDokumentuSp.typFK == "FWS" || xTypDokumentuSp.typFK == "FWSK") then //&& czyPozycjaVAT then //nowy typ dokumentu w FK - wielowalutowy
			dst.RejestrVAT.PozycjaVAT.MoveKursVAT()
			dst.RejestrVAT.PozycjaVAT.Value("TypExt") = 1
			dst.RejestrVAT.PozycjaVAT.Value("Nazwa") = xDokumentSp.waluta
			dst.RejestrVAT.PozycjaVAT.Value("Wartosc") = xDokumentSp.kurs

			dst.RejestrVAT.PozycjaVAT.MoveKursCITPIT()
			dst.RejestrVAT.PozycjaVAT.Value("TypExt") = 2
			dst.RejestrVAT.PozycjaVAT.Value("Nazwa") = xDokumentSp.waluta
			dst.RejestrVAT.PozycjaVAT.Value("Wartosc") = xDokumentSp.kursDoch
		endif

		TabPozVat.ClearRec()
		float wartosc
		dispatch pozycja
		////////////////////////[Pozycja VAT] - koniec ///////////////
		for ii=1 to ii>(xDokumentSp.Pozycje.Count())
			if (!xDokumentSp.Pozycje.item(ii).dokompletu && ((!xDokumentSp.CzyKorekta) || (xDokumentSp.CzyKorekta && xDokumentSp.Pozycje.item(ii).wlasna))) then
				if (xDokumentSp.CzyKorekta) then
					wartosc = 0
					if (xDokumentSp.Pozycje.item(ii).idpozkoryg) then
						pozycja = xDokumentSp.Pozycje.item(ii).przedKorekta
						xRejSp = pozycja.rejestrVAT
						iRejVat = xRejSp.rejestrFKid
						dpStVat = pozycja.stVAT
						TabRejVat.Wstaw(iRejVat,dpStVat, pozycja,1,0, 1)
						//////////////////////////////[Pozycja VAT]///////////////
						wartosc = - (pozycja.niePodlega + pozycja.netto)
					endif

					pozycja = xDokumentSp.Pozycje.item(ii).poKorekcie
					xRejSp = pozycja.rejestrVAT
					iRejVat = xRejSp.rejestrFKid
					dpStVat = pozycja.stVAT
					TabRejVat.Wstaw(iRejVat,dpStVat, pozycja,1,0, 0)
					//////////////////////////////[Pozycja VAT]///////////////
					wartosc = wartosc + (pozycja.niePodlega + pozycja.netto)
					if czyPozycjaVAT then TabPozVat.Wstaw(pozycja, round(wartosc,2), czyDEX)
				else
					pozycja = xDokumentSp.Pozycje.item(ii)
					xRejSp = pozycja.rejestrVAT
					iRejVat = xRejSp.rejestrFKid
					dpStVat = pozycja.stVAT
					TabRejVat.Wstaw(iRejVat,dpStVat, pozycja,1,0, 0)
					//////////////////////////////[Pozycja VAT]///////////////
					if czyPozycjaVAT then
						wartosc = pozycja.niePodlega + pozycja.netto
						TabPozVat.Wstaw(pozycja, round(wartosc,2), czyDEX)
					endif
				endif
				DodajDoOpisu(xDokumentSp.Pozycje.item(ii).opis, "/")
			endif
		next ii

		dst.Value("nazwa") = xDokumentSp.numer

		xDekretacjeSp.Clear()
		xDekretParams = xDekretacjeSp.Params()
		xDekretParams.id=xDokumentSp.id
		xDekretacjeSp.Dekret(xDekretParams)
		dst.Value("tresc")	= xDekretacjeSp.trescwFK  //opis fk
		ZapiszZAP(xDekretacjeSp, 0, 0, xDokumentSp.czyRozliczony,xDokumentSp.terminPlatnosci, nWalutowy, xDokumentSp.waluta, !czyRelatedDokument)
		// rwnolege ksigowania magazynowe
		if iOpcje & ROWNOLEGLE_KSIEG_MAG then
			if !bKorekta then
				for ii=1 to ii>xDokumentSp.transakcjaTw.powiazaniaTw.Count()
					nRes=!(xDokumentMg=GetObjById("BDokumentMg",xDokumentSp.transakcjaTw.powiazaniaTw.item(ii).idWlascicielaTrans))
					if nRes then  error "Dokument nie zaadowany"
					if ( xDokumentMg.czyWystawiony && !IntegrZatwWart(xDokumentMg, xDokumentSp.numer) ) then
						if ( !((iOpcje & NIE_EKSP_OZNAK) && xDokumentMg.czyWyeksportFK) ) then
							xDekretacjeMg.Clear()
							xDekretParams = xDekretacjeMg.Params()
							xDekretParams.id = xDokumentMg.id
							xDekretacjeMg.Dekret(xDekretParams)

							if(xTypDokumentuSp.typFK == "FWS" || xTypDokumentuSp.typFK == "FWSK")  then //nowy typ dokumentu w FK - wielowalutowy
							//ewentualne rownolegle ksiegowanie magazynowe tylko w PLN
								ZapiszZAP(xDekretacjeMg, 1, 0, 0, xDokumentMg.termin, 0, "", 0)
							else
								ZapiszZAP(xDekretacjeMg, 1, 0, 0, xDokumentMg.termin, nWalutowy, xDokumentSp.waluta, 0)
							endif

						else
							eksport.AddInfo("Nie mona powtrnie wyeksportowa zapisw do dokumentu " + xDokumentMg.numer + ".")
						endif
					endif
				next ii
			endif
			//korekta i innne korekty
			for ii=1 to ii>xDokumentSp.zwiazkiOdpDok.Count()
				if ((xDokumentSp.zwiazkiOdpDok.item(ii).dkBase == 33) && xDokumentSp.zwiazkiOdpDok.item(ii).idDk) then
					nRes=!(xDokumentMg=GetObjById("BDokumentMg",xDokumentSp.zwiazkiOdpDok.item(ii).idDk))
					if nRes then  error "Dokument nie zaadowany"
					if ( xDokumentMg.czyWystawiony && !IntegrZatwWart(xDokumentMg, xDokumentSp.numer) ) then
						if ( !((iOpcje & NIE_EKSP_OZNAK) && xDokumentMg.czyWyeksportFK) ) then
							xDekretacjeMg.Clear()
							xDekretParams = xDekretacjeMg.Params()
							xDekretParams.id = xDokumentMg.id
							xDekretacjeMg.Dekret(xDekretParams)

							if(xTypDokumentuSp.typFK == "FWS" || xTypDokumentuSp.typFK == "FWSK")  then //nowy typ dokumentu w FK - wielowalutowy
							//ewentualne rownolegle ksiegowanie magazynowe tylko w PLN
								ZapiszZAP(xDekretacjeMg, 1, 0, 0, xDokumentMg.termin, 0, "", 0)
							else
								ZapiszZAP(xDekretacjeMg, 1, 0, 0, xDokumentMg.termin, nWalutowy, xDokumentSp.waluta, 0)
							endif
						else
							eksport.AddInfo("Nie mona powtrnie wyeksportowa zapisw do dokumentu " + xDokumentMg.numer + ".")
						endif
					endif
				endif
			next ii
		endif // rwnolege ksigowania magazynowe

		ZapiszETRANSFERS(xDokumentSp, xDekretacjeSp)

		long lStawka
		float dStawka
		string opis = ""
		// rejestry VAT
		iSubtyp = xDokumentSp.charakter
		Select Case iSubtyp
			Case FVS, FKS, RUS, RKS, PAR, PRK, FAS, FAK, FVW, FKW, FZS, ZKS, WDT, FWS, WKS, WDK, FVT, FTK, REX, RXK, SZA, SZK //, SKO, SKK

				for iPom=1 to iPom>TabRejVat.IloscRejestrow(0)
					for iPomStVat=1 to iPomStVat>TabRejVat.IloscStawek(iPom)
						dst.RejestrVAT.Insert()
						if ItgInfo.Info("VATMP") then
							// VAT naliczony metoda kasowa
							dst.RejestrVAT.Value("oczek") = iif((xDokumentSp.metodaVAT),DOV_ZAPLATA,DOV_OKRES)
						endif

						dst.RejestrVAT.Value("soczek") = dst.RejestrVAT.Value("oczek")

						dst.RejestrVAT.Value("def") = TabRejVat.RejVat(iPom).id
						dst.RejestrVAT.Value("typabc") = 1
						buf = xDokumentSp.dataRejestrVAT
						strOkres = Find Regular "????????" // osiem pierwszych znakw
						dst.RejestrVAT.Value("okres") = strOkres + "01"
						dst.RejestrVAT.Value("datadok") = xDokumentSp.dataWystawienia
						dst.RejestrVAT.Value("dataws") = xDokumentSp.dataSprzedazy
						dst.RejestrVAT.Value("stawka") = TabRejVat.Wartosc(iPom, iPomStVat, "stawka")
						dst.RejestrVAT.Value("brutto") = Round( (TabRejVat.Wartosc(iPom, iPomStVat, "netto") + TabRejVat.Wartosc(iPom, iPomStVat, "vat")),2 )
						dst.RejestrVAT.Value("netto") = Round( TabRejVat.Wartosc(iPom, iPomStVat, "netto"),2 )
						dst.RejestrVAT.Value("vat") = Round( TabRejVat.Wartosc(iPom, iPomStVat, "vat"),2 )

						if(nWalutowy &&(xTypDokumentuSp.typFK == "FWS" || xTypDokumentuSp.typFK == "FWSK"))  then //nowy typ dokumentu w FK - wielowalutowy
							dst.RejestrVAT.Value("bruttoWaluta") = Round(TabRejVat.Wartosc(iPom, iPomStVat, "wbrutto"),2)
							dst.RejestrVAT.Value("nettoWaluta") = Round( TabRejVat.Wartosc(iPom, iPomStVat, "wnetto"),2)
							dst.RejestrVAT.Value("vatWaluta") = Round((TabRejVat.Wartosc(iPom, iPomStVat, "wbrutto") - TabRejVat.Wartosc(iPom, iPomStVat, "wnetto")),2)
						endif
						dst.RejestrVAT.Value("UE") = 0
					next iPomStVat
					//////////////////////////////[Pozycja VAT]///////////////
					if (czyPozycjaVAT) then
						for iPos=1 to iPos > TabPozVat.Rozmiar()
							if TabPozVat.PozVat(iPos).rejestrVat == TabRejVat.RejVat(iPom).id then
								dst.RejestrVAT.PozycjaVAT.Insert()
								lStawka = TabPozVat.PozVat(iPos).stawka
								dStawka = TabPozVat.StVat(TabPozVat.ZnajdzStawke(lStawka)).stawka
								dst.RejestrVAT.PozycjaVAT.Value("Stawka") = dStawka
								//towar
								if TabPozVat.PozVat(iPos).towar != "" then
									if (xTowar = GetObjByKod("BTowar", TabPozVat.PozVat(iPos).towar)) then
										opis = xTowar.nazwa
										lStawka = TabPozVat.StVat(TabPozVat.InitStawke(xTowar.stVAT)).id
										dStawka = TabPozVat.StVat(TabPozVat.ZnajdzStawke(lStawka)).stawka
									endif
								else
									opis = TabPozVat.PozVat(iPos).opis
								endif

								opis = NormalizeString(opis, lOPIS)

								dst.RejestrVAT.PozycjaVAT.Value("Stawka_pl") = dStawka
								dst.RejestrVAT.PozycjaVAT.Value("Nazwa") = opis
								dst.RejestrVAT.PozycjaVAT.Value("Wartosc") = TabPozVat.PozVat(iPos).wartosc
								dst.RejestrVAT.PozycjaVAT.Value("Usluga") = TabPozVat.PozVat(iPos).usluga
								dst.RejestrVAT.PozycjaVAT.Value("UE") = TabPozVat.PozVat(iPos).UE
							endif
						next iPos
					endif
				next iPom

			Case DEX, DXK

				for iPom=1 to iPom>TabRejVat.IloscRejestrow(0)
					for iPomStVat=1 to iPomStVat>TabRejVat.IloscStawek(iPom)
						dst.RejestrVAT.Insert()
						if ItgInfo.Info("VATMP") then
							// VAT naliczony metoda kasowa
							dst.RejestrVAT.Value("oczek") = iif((xDokumentSp.metodaVAT),DOV_ZAPLATA,DOV_OKRES)
						endif

						dst.RejestrVAT.Value("def") = TabRejVat.RejVat(iPom).id
						dst.RejestrVAT.Value("typabc") = 1
						buf = xDokumentSp.dataRejestrVAT
						strOkres = Find Regular "????????" // osiem pierwszych znakw
						dst.RejestrVAT.Value("okres") = strOkres + "01"
						dst.RejestrVAT.Value("datadok") = xDokumentSp.dataWystawienia
						dst.RejestrVAT.Value("dataws") = xDokumentSp.dataSprzedazy

						dst.RejestrVAT.Value("stawka") = TabRejVat.Wartosc(iPom, iPomStVat, "stawka")
						if dst.RejestrVAT.Value("stawka") != -2 then
							dst.RejestrVAT.Value("stawka") = 0
						endif
						dst.RejestrVAT.Value("brutto") = Round( (TabRejVat.Wartosc(iPom, iPomStVat, "netto") + TabRejVat.Wartosc(iPom, iPomStVat, "vat")),2 )
						dst.RejestrVAT.Value("netto") = Round( TabRejVat.Wartosc(iPom, iPomStVat, "netto"),2 )
						dst.RejestrVAT.Value("vat") = Round( TabRejVat.Wartosc(iPom, iPomStVat, "vat"),2 )
						dst.RejestrVAT.Value("UE") = 0
					next iPomStVat
					//////////////////////////////[Pozycja VAT]///////////////
					if (czyPozycjaVAT) then
						for iPos=1 to iPos > TabPozVat.Rozmiar()
							if TabPozVat.PozVat(iPos).rejestrVat == TabRejVat.RejVat(iPom).id then
								dst.RejestrVAT.PozycjaVAT.Insert()
								lStawka = TabPozVat.PozVat(iPos).stawka
								dStawka = TabPozVat.StVat(TabPozVat.ZnajdzStawke(lStawka)).stawka
								dst.RejestrVAT.PozycjaVAT.Value("Stawka") = dStawka
								//towar
								if TabPozVat.PozVat(iPos).towar != "" then
									if (xTowar = GetObjByKod("BTowar", TabPozVat.PozVat(iPos).towar)) then
										opis = xTowar.nazwa
										lStawka = TabPozVat.StVat(TabPozVat.InitStawke(xTowar.stVAT)).id
										dStawka = TabPozVat.StVat(TabPozVat.ZnajdzStawke(lStawka)).stawka
									endif
								else
									opis = TabPozVat.PozVat(iPos).opis
								endif

								opis = NormalizeString(opis, lOPIS)

								dst.RejestrVAT.PozycjaVAT.Value("Stawka_pl") = dStawka
								dst.RejestrVAT.PozycjaVAT.Value("Nazwa") = opis
								dst.RejestrVAT.PozycjaVAT.Value("Wartosc") = TabPozVat.PozVat(iPos).wartosc
								dst.RejestrVAT.PozycjaVAT.Value("Usluga") = TabPozVat.PozVat(iPos).usluga
								dst.RejestrVAT.PozycjaVAT.Value("UE") = TabPozVat.PozVat(iPos).UE
							endif
						next iPos
					endif
				next iPom
		EndSelect

		TabRejVat.IloscRejestrow(-1)
		TabRejVat.ClearRec()

		//FWS jest wielowalutowy, wiec czyscimy dla dokumentu walutowosc
		//if ( xDokumentSp.charakter == FVW || xDokumentSp.charakter == FKW) && (xTypDokumentuSp.typFK == "FWS" || xTypDokumentuSp.typFK == "FWSK") then
		if (xTypDokumentuSp.typFK == "FWS" || xTypDokumentuSp.typFK == "FWSK") then //nie tylko dla faktury w walucie
			dst.Value("waluta") = ""
			dKurs = 0
			dst.Value("kurs") = dKurs
			dst.Value("wkwota") = dKurs
		endif
		
		if (xIntegracja.CzyItgXML == 1 && xDokumentSp.statusRDF) then
			dst.ValidateForXML()
		else
			dst.Validate()
		endif
		if (ers.Count) then IntegrDK = ShowError( xDokumentSp.nazwa+" "+xDokumentSp.numer)
	
		if(IntegrDK == 0) then
			if (xIntegracja.CzyItgXML == 1 && xDokumentSp.statusRDF) then
				xmlDoc = dst.GiveXML(0)
				xParams = xfactory.NewObject("BDekretacjeXml")
				xParams.guid = xDokumentSp.guid
				xparams.tresc = xmlDoc
				xIntegracja.ZapiszXMLwRDF(xParams)
			EndIf
//                                                                    ---- WYLACZONE 2015-12-03 ----
//			If ( xIntegracja.CzyItgXML != 1 || !xDokumentSp.statusRDF || FunctionalityDimensioning() ) Then
			If ( xIntegracja.CzyItgXML != 1 || !xDokumentSp.statusRDF ) Then
				// --------------------------------------------------------------------------------
				// 2015-10-01
				// Z powodu braku informacji o wymiarowaniu w XML'u niezbedny jest zapis do FK dokumentu z wymiarowaniem
				IntegrDK = !dst.Insert()
				// --------------------------------------------------------------------------------
			EndIf
		endif
		ShowStatus(xDokumentSp.numer,idDK, IntegrDK)
EndSub

int Sub BeginProcessDK()
	TabRejVat.ClearRec()
EndSub


int Sub DoProcessDK(long idDK)
	DoProcessDK = 0
	rozUidStrona = ROZ_STRONA_WN
	int iVal, err
	int iOpcje = 0
	long ii
	Dispatch xDokSp
	Dispatch xDokMg

	nRes=!(xDokumentSp=GetObjById("BDokumentSp",idDK))
	if nRes then  Error "Brak takiego rekordu w bazie DK"


	nRes=!(xDokSp=GetObjById("BDokSp",idDK))
	if nRes then  error "Dokument nie zaadowany"

	if ( xDokSp.czyBufor ) then
		DoProcessDK = 1 // pomijamy
		AddError("Nie mona wysa niezatwierdzonego dokumentu " + xDokumentSp.numer+".",idDK)
		Exit // nie wysyamy dokumentw z bufora
	endif

	if ( xDokSp.czyAnulowany ) then
		DoProcessDK = 1 // pomijamy
		AddError("Nie mona wysa anulowanego dokumentu " + xDokumentSp.numer+".",idDK)
		Exit // nie wysyamy dokumentw anulowanych
	endif

	if (xDokumentSp.charakter == SKO || xDokumentSp.charakter == SKK) && (xDokumentSp.dataRealizacji == "")then
		DoProcessDK = 1 // pomijamy
		AddError("Nie mona wysa kontraktu z nieokrelon dat realizacji " + xDokumentSp.numer+".",idDK)
		Exit //nie wysyamy kontraktw bez okrelonej daty realizacji
	endif

	if ( iNieIntegrOznak && xDokSp.czyWyekspFK ) then
		DoProcessDK = 1 // pomijamy
		AddError("Nie mona powtrnie wysa dokumentu " + xDokumentSp.numer+".",idDK)
		Exit // nie wysyamy oznakowanych dokumentw
	endif

	// czy rwnolege ksigowanie magazynowe
	if ( iRownoKsiegMag ) then iOpcje |= ROWNOLEGLE_KSIEG_MAG

	if ( iNieIntegrOznak ) then iOpcje |= NIE_EKSP_OZNAK

	TabRejVat.ClearRec()
	DoProcessDK = IntegrDK(idDK, iOpcje)
	if	DoProcessDK then Exit	 // pomijamy

	/////////////////////////////////////////////////
	// oznaczamy wysane dokumenty
	if ( iOznaczaj ) then
		nRes=!(xDokumentSp=GetObjById("BDokumentSp",idDK))
		if nRes then  Error "Brak takiego rekordu w bazie DK"

		xDokSp.Clear()
		nRes=!(xDokSp=GetObjById("BDokSp",idDK))
		if nRes then  error "Dokument nie zaadowany"
		xDokSp.SetEkspFK()

		// dokumenty magazynowe rozliczajce dokument handlowy
		if ( iRownoKsiegMag ) then
			if ( !xDokumentSp.czyKorekta )then
				xDokumentSp.transakcjaTw.powiazaniaTw.PokazujIstniejace()
				for ii=1 to ii>xDokumentSp.transakcjaTw.powiazaniaTw.Count()
					// !!! sprawdzic jak sie wysyla nie zatwierdzone wartosciowo
					nRes=!(xDokumentMg=GetObjById("BDokumentMg",xDokumentSp.transakcjaTw.powiazaniaTw.item(ii).idWlascicielaTrans))
					if nRes then  error "Dokument nie zaadowany"

					if (xDokumentMg.czyWystawiony) then

						nRes = !(xDokMg=GetObjById("BDokMg",xDokumentMg.id))
						if nRes then  error "Dokument nie zaadowany"

						xDokMg.SetEkspFK()
					endif
				next ii
			endif
			for ii=1 to ii>xDokumentSp.zwiazkiOdpDok.Count()
				if ((xDokumentSp.zwiazkiOdpDok.item(ii).dkBase == 33) && xDokumentSp.zwiazkiOdpDok.item(ii).idDk) then
					nRes=!(xDokumentMg=GetObjById("BDokumentMg",xDokumentSp.zwiazkiOdpDok.item(ii).idDk))
					if nRes then  error "Dokument nie zaadowany"
					if (xDokumentMg.czyWystawiony) then

						nRes = !(xDokMg=GetObjByID("BDokMg",xDokumentMg.id))
						if nRes then  error "Dokument nie zaadowany"

						xDokMg.SetEkspFK()
					endif
				endif
			next ii
		endif
	endif
EndSub

int Sub EndProcessDK()
EndSub
